//-------------------------------------------------
//
//
// Programm zum Testen des Empfangs der Infrarot-Strahlung
// des RoboCup-Balls. Die Differenz der Analogsensoren 1-7
// mit Analog0 wird bei Tastendruck (digital0) auf das LCD
// und die serielle SS ausgegeben
//
//
// 01.02.05
// I. Boersch
//
//-------------------------------------------------

#include <stdio.h>
#include <regc515c.h>
#include "stub.h"
#include "serielle.h"

// Ausgabe eines Wertes w an Position p auf dem LCD
void posout(unsigned char p, unsigned char w)
{
    if (p<4) lcd_setxy(0,p*4);
    else if (p<8) lcd_setxy(1,p*4);
    else return;

    lcd_ubyte(w);
    if (p<10) lcd_putchar(' ');
    if (p<100) lcd_putchar(' ');
}


// Ausgabe eines Wertes w an Position p auf RS232
void sposout(unsigned char w)
{
    if ((w/100) > 0) serielle_putchar((w/100)+'0'); else serielle_putchar(' ');
    if ((w%100)/10 > 0 ) serielle_putchar((w%100)/10+'0'); else serielle_putchar(' ');
    if (w%10 > 0) serielle_putchar((w%10)+'0'); else serielle_putchar(' ');
    serielle_putchar(' ');
}


// Zeilenumbruch ber RS232
void senter()
{
    serielle_putchar(0x0d);
    serielle_putchar(0x0a);
}


void AksenMain(void)
{
    unsigned char i;
    int w;

    serielle_init();
    lcd_cls();

    do
    {
        sleep(50);
        while(digital_in(0));                     // Warten auf Taster

        for(i = 0; i < 7 ; i++)
        {
            w = analog(7) - analog(0);
            if ( w < 0 ) w = 0;
            posout(i,(unsigned char)w);
            sposout((unsigned char)w);
        }
        senter();

    } while(1);
}
