/*
 * 1-Erzeuger-3-Verbraucher-System mit Semaphoren
 * Autor: I. Boersch 05/2004
 *
 */

#include <stub.h>
#include "sema.h"

int puffer[10];
int MUTEX=1;                                      // nicht notwendig, nur zur Demo kritischer Abschnitt
int FULL=2;
int EMPTY=3;
int FOTOZELLE=13;

void lampe(int id)
{
    motor_richtung(id,1);
    motor_pwm(id,10);
}


// Alles aus
void ao()
{
    motor_pwm(0,0);
    motor_pwm(1,0);
    motor_pwm(2,0);
    motor_pwm(3,0);
}


void producer()
{
    int i;
    while(1)
    {
        S_down(EMPTY);
        S_down(MUTEX);
        for(i=0;i<10;i++)
        {
            puffer[i]=analog(FOTOZELLE);
        }
        ao();                                     /* Alles aus */
        lampe(0);
        sleep(400);
        ao();
        S_up(MUTEX);
        S_up(FULL);
    }
}


void consumer_share(int id)
{
    int i,wert;
    while(1)
    {
        wert=0;                                   /* Wird gern vergessen */
        S_down(FULL);
        S_down(MUTEX);
        for(i=0;i<10;i++)
        {
            wert+=puffer[i];
            puffer[i]=0;
        }

        // Ausgabe
        lcd_cls();
        lcd_puts("MWert = ");
        lcd_uint(wert/10);

        ao();                                     /* Alles aus  */
        lampe(id);
        sleep(400);
        ao();
        S_up(MUTEX);
        S_up(EMPTY);
        sleep(4000);
    }
}


void consumer1() {consumer_share(1);}
void consumer2() {consumer_share(2);}
void consumer3() {consumer_share(3);}

void AksenMain()
{
    int pid_P,pid_C1,pid_C2,pid_C3;

    S_init(MUTEX,1);
    S_init(EMPTY,1);
    S_init(FULL,0);
    pid_P=process_start(producer,50);
    pid_C1=process_start(consumer3,50);
    pid_C2=process_start(consumer1,50);
    pid_C3=process_start(consumer2,50);

    process_kill( process_get_pid());
}
