/*
 * sema.c
 * Implementation der binaeren Semaphore
 * Funktionen:
 * void  S_init(int s,int wert);
 * void  S_up(int s);
 * void  S_down(int s);
 * int tsl(int s);
 * I. Boersch 05/2004
 */

#include <regc515c.h>
#include <stub.h>
#include "sema.h"

int sem[10];                                      /* bis zu 10 Semaphore mgl */

void error(char *s)
{
    lcd_cls();
    lcd_puts(s);
}


void S_init(int s,int wert)
{
    sem[s]=wert;
}


/* UP */
void S_up(int s)
{
    if( sem[s]==0 ) sem[s]=1;
    else error("Error: S_up()");
}


/* DOWN */
void S_down(int s)
{
    /* Warten bis Semaphor frei wird */
    while( tsl(s) );
}


/* TSL-Anweisung */
int tsl(int s)
{
    /* Keine Interrupts bitte */
    process_hog();
    if(sem[s]==1)
    {
        /* Semaphor belegen */
        sem[s]=0;
        process_defer();
        return (0);
    }
    else
    {
        /* Semaphor ist belegt */
        process_defer();
        return (1);
    }
}
