/***********************************************/
/*                                             */
/* Erkennen einer auf den 40kHz-Trger mod.    */
/* Frequenz									   */
/*                                             */
/* 19.01.2004                                  */
/* K.-U. Mrkor                                 */
/*                                             */
/***********************************************/

#include <stdio.h>
#include <regc515c.h>
#include "stub.h"

/************************************************/
/* MAIN-Routine									*/
/************************************************/
void AksenMain(void)
{

    /************************************/
    /* Zuordnung der Empfangseingaenge: */
    /*									*/
    /*  D04 -> mod_ir0_empf   			*/
    /*  D05 -> mod_ir1_empf 			*/
    /*  D06 -> mod_ir2_empf  			*/
    /*  D07 -> mod_ir3_empf  			*/
    /*									*/
    /************************************/

    /********************************************************************/
    /* Wert fuer mod_irX_takt() ergibt sich aus halber Periodendauer    */
    /* der gesuchten Frequenz in ms								        */
    /*                                                                  */
    /* mod_ir_senden  | Frequenz                                        */
    /* --------------------------                                       */
    /*   0            | deaktiviert                                     */
    /*   4            |  125 Hz                                         */
    /*   5            |  100 Hz                                         */
    /********************************************************************/

    mod_ir0_takt(4);                              /* 125 Hz */
    mod_ir0_maxfehler(3);                         /* maximal 3 Fehler je Periode */

    do
    {
        lcd_cls();
        lcd_setxy(0,0);
        lcd_puts("IR-Empfang - IR0");

        lcd_setxy(1,0);
        lcd_puts("125Hz -> ");
        lcd_ubyte( mod_ir0_status() );
        sleep(200);

    }
    while(1);

}
