/****************************************/
/*                                      */
/* Beispielprogramm Linien-Folger       */
/* Autor: I. Boersch, 02/2004           */
/*                                      */
/****************************************/

#include <stdio.h>
#include <regc515c.h>
#include <stub.h>

#define O_LINKS 0                                 // Anschlussports der drei Optokoppler
#define O_MITTE 1
#define O_RECHTS 2

#define M_LINKS 3                                 // Anschlussports der beiden Motore
#define M_RECHTS 2

#define SCHNELL 10                                // Geschwindigkeitsdefinitionen
#define MITTEL 7
#define LANGSAM 1

#define MAX_NO_BLACK 180                          // maximale Fahrzeit ohne Linie
#define schwarz(x) (x > 150)

void sensor(unsigned char *o_links, unsigned char *o_rechts, unsigned char *o_mitte)
{
    *o_links = analog(O_LINKS);
    *o_mitte = analog(O_MITTE);
    *o_rechts = analog(O_RECHTS);
}


void AksenMain(void)
{
    unsigned int no_black = 0;
    unsigned char o_links, o_mitte, o_rechts;

    led(3,1);                                     // Optokoppler an
    led(1,1);

    motor_richtung(M_LINKS,1);                    // Motoren nur vorwrts
    motor_richtung(M_RECHTS,1);

    do                                            // EVA-Schleife
    {
        sensor(&o_links, &o_rechts, &o_mitte);

        lcd_cls();
        lcd_setxy(0,0);
        lcd_puts("L="); lcd_ubyte(o_links);
        lcd_puts("M="); lcd_ubyte(o_mitte);
        lcd_puts("R="); lcd_ubyte(o_rechts);

        if (schwarz(o_rechts))
        {
            no_black = 0;
            motor_pwm(M_RECHTS,LANGSAM);
            motor_pwm(M_LINKS,MITTEL);
        }
        else if (schwarz(o_links))
        {
            no_black = 0;
            motor_pwm(M_RECHTS,MITTEL);
            motor_pwm(M_LINKS,LANGSAM);
        }
        else if (schwarz(o_mitte))
        {
            no_black = 0;
            motor_pwm(M_RECHTS,SCHNELL);
            motor_pwm(M_LINKS,SCHNELL);
        }
        else if (no_black > MAX_NO_BLACK)
        {
            motor_pwm(M_RECHTS,0);
            motor_pwm(M_LINKS,0);
            lcd_puts("Linie verloren \n stop");
            while(1);
        }
        else
        {
            no_black++;
        }

    } while(1);
}
