/***********************************************/
/*                                             */
/* 12 Blinker- und 8 Servoprozesse             */
/*                                             */
/* 01.02.05                                    */
/* I. Boersch                                  */
/*                                             */
/***********************************************/

#include <stdio.h>
#include <regc515c.h>
#include <stub.h>

#define WAIT_BEFORE_START 1000
#define HALF_PERIOD 500

void set_servo(unsigned char s, unsigned int ms)
{
    if ( s < 3 )        servo(s,ms);
    else if ( s < 11 )  servobank(s-3,ms);
}


// Prozessklasse Servo
void servobank_test( unsigned char servo, unsigned int zeit)
{
    unsigned int servozeit;
    servozeit=zeit;

    do
    {
        sleep(500);

        servozeit+=10;
        if (servozeit>2100) servozeit=600;

        set_servo(servo,servozeit);
    }
    while(1);
}


// Prozessobject Servo
void servo0_test() { servobank_test(0,1000);}
void servo1_test() { servobank_test(1,1010);}
void servo2_test() { servobank_test(2,1020);}
void servo3_test() { servobank_test(3,1030);}
void servo4_test() { servobank_test(4,1040);}
void servo5_test() { servobank_test(5,1050);}
void servo6_test() { servobank_test(6,1060);}
void servo7_test() { servobank_test(7,1070);}

// Prozessklasse Blink
void blink(unsigned char id)
{

    while(1)
    {
        lcd_setxy(0,id);
        lcd_putchar('_');
        if (id < 4 ) led(id,0);

        sleep(HALF_PERIOD);

        if (id < 4 ) led(id,1);
        lcd_setxy(0,id);
        lcd_putchar('A'+id);

        sleep(HALF_PERIOD);
    }
}


// Prozessobject Blink
void p0( void) {blink(0);}
void p1( void) {blink(1);}
void p2( void) {blink(2);}
void p3( void) {blink(3);}
void p4( void) {blink(4);}
void p5( void) {blink(5);}
void p6( void) {blink(6);}
void p7( void) {blink(7);}
void p8( void) {blink(8);}
void p9( void) {blink(9);}
void p10( void) {blink(10);}
void p11( void) {blink(11);}
void p12( void) {blink(12);}
void p13( void) {blink(13);}
void p14( void) {blink(14);}
void p15( void) {blink(15);}
void p16( void) {blink(16);}

/************************************************/
/* MAIN-Routine									*/
/************************************************/
void AksenMain(void)
{

    /* Starten der Prozesse */
    process_start( servo0_test, 150);
    process_start( servo1_test, 160);
    process_start( servo2_test, 170);
    process_start( servo3_test, 180);
    process_start( servo4_test, 190);
    process_start( servo5_test, 200);
    process_start( servo6_test, 210);
    process_start( servo7_test, 220);

    servobank_start();
    sleep(5000);                                  // alles ok? kein Zittern, dann weiter ..

    process_start( p0, 10); sleep(WAIT_BEFORE_START);
    process_start( p1, 10); sleep(WAIT_BEFORE_START);
    process_start( p2, 10); sleep(WAIT_BEFORE_START);
    process_start( p3, 10); sleep(WAIT_BEFORE_START);
    process_start( p4, 10); sleep(WAIT_BEFORE_START);
    process_start( p5, 10); sleep(WAIT_BEFORE_START);
    process_start( p6, 10); sleep(WAIT_BEFORE_START);
    process_start( p7, 10); sleep(WAIT_BEFORE_START);
    process_start( p8, 10); sleep(WAIT_BEFORE_START);
    process_start( p9, 10); sleep(WAIT_BEFORE_START);
    process_start( p10, 10); sleep(WAIT_BEFORE_START);

    p11();
}
