/***********************************************/
/*                                             */
/* Ansteuerung aller 11 Servos ber msek:     */
/* Servos reagieren auf Poti an analog0        */
/* Somit lassen sich die spezifischen          */
/* Ansteuerintervalle einzelner Servos durch   */
/* Beobachten des Stromverbrauchs bestimmen    */
/*                                             */
/* mikrosekunden == 0 heisst Servo aus         */
/*                                             */
/* 06.01.2005                                  */
/* I. Boersch                                  */
/*                                             */
/***********************************************/

#include <stdio.h>
#include <regc515c.h>
#include <stub.h>

/************************************************/
/* MAIN-Routine									*/
/************************************************/
void set_servo(unsigned char s, unsigned int ms)
{
    if ( s < 3 )        servo(s,ms);
    else if ( s < 11 )  servobank(s-3,ms);
}


void AksenMain(void)
{
    unsigned int mikrosekunden=200;
    unsigned char s;

    lcd_puts("Servos mit ms");

    servobank_start();                            // 8 Servos zustzlich

    do
    {
        mikrosekunden = analog(0) * 10;

        for( s = 0; s < 11; s++) set_servo(s,mikrosekunden);

        lcd_setxy(1,0);
        lcd_uint(mikrosekunden);
        if (mikrosekunden < 1000) lcd_putchar(' ');
        if (mikrosekunden < 100)  lcd_putchar(' ');
    }
    while(1);
}
