/***********************************************/
/*                                             */
/* Test der Servobank 						   */
/*                                             */
/* 22.07.2004                                  */
/* K.-U. Mrkor                                 */
/*                                             */
/***********************************************/

#include <stdio.h>
#include <regc515c.h>
#include <stub.h>

void led_test( unsigned char lummi, unsigned int zeit)
{
    do
    {
        led(lummi,0);
        sleep(zeit);                              /* >= zeit */
        led(lummi,1);
        sleep(zeit);                              /* >= zeit */

    }
    while(1);
}


void led0() { led_test(0,300);}
void led1() { led_test(1,600);}
void led2() { led_test(2,900);}
void led3() { led_test(3,1200);}

void servobank_test( unsigned char servo, unsigned int zeit)
{
    unsigned int servozeit;

    servozeit=zeit;

    do
    {
        sleep(50);

        servozeit+=10;
        if (servozeit>2100)
            servozeit=600;

        servobank(servo,servozeit);

    }
    while(1);
}


void servo0_test() { servobank_test(0,1000);}
void servo1_test() { servobank_test(1,1010);}
void servo2_test() { servobank_test(2,1020);}
void servo3_test() { servobank_test(3,1030);}
void servo4_test() { servobank_test(4,1040);}
void servo5_test() { servobank_test(5,1050);}
void servo6_test() { servobank_test(6,1060);}
void servo7_test() { servobank_test(7,1070);}

/************************************************/
/* MAIN-Routine									*/
/************************************************/
void AksenMain(void)
{

    lcd_setxy(0,0);

    process_start( led0, 200);
    process_start( led1, 200);
    process_start( led2, 200);
    process_start( led3, 200);

    process_start( servo0_test, 150);
    process_start( servo1_test, 160);
    process_start( servo2_test, 170);
    process_start( servo3_test, 180);
    process_start( servo4_test, 190);
    process_start( servo5_test, 200);
    process_start( servo6_test, 210);
    process_start( servo7_test, 220);
    lcd_puts("Prozesse laufen");

    lcd_setxy(1,0);
    lcd_puts("Servobank laeuft");
    servobank_start();

    /* Der Prozess AksenMain() beendet sich selbst (das Leben ist halt grausam) */
    process_kill( process_get_pid());

}
