/***********************************************/
/*                                             */
/* "Werbe"-Programm fr das AKSEN-Board        */
/*                                             */
/*                                             */
/* 28.11.2003                                  */
/* K.-U. Mrkor                                 */
/*                                             */
/***********************************************/

#include <stdio.h>
#include <regc515c.h>
#include "stub.h"

unsigned char xdata rot_puffer[50];
unsigned char xdata lcd=0, laempchen=0, motor=0, infrarot=0;
unsigned long xdata warte_zaehler=0;

unsigned char xdata puffer[2][16];
unsigned int xdata laenge;

unsigned int xdata werbe_zeiger=0;

const unsigned char code werbung[]=
{ \
    "Willkommen beim Tutorial zum AKSEN-Board.\\
    Einem universellen Controller-Board zum kostenguenstigen Bau von kleinen autonomen Robotern.\\
    Es zeichnet sich durch hohe Flexibilitaet, vielfaeltige Erweiterungsmoeglichkeiten und einfache Programmierbarkeit aus.\\
    Fuer die Programm-Entwicklung in C kann ein beliebiger Windows- oder Linux-PC verwendet werden.\\
    Die Programmablage auf dem Board erfolgt in einem Flash-Speicher und ist somit auch nach einer Trennung vom Akku gesichert.\\
    Das komplette Board wurde schon bei der Entwicklung auf einen geringen Stromverbrauch optimiert.\\
    Folgende Anschluesse sind vorhanden: 15 analoge Eingaenge, 16 digitale Ein-/Ausgaenge, vier Motortreiber,\\
    vier schaltbare Leistungstreiber, drei bis elf Servo-Ausgaenge, ein Infrarotausgang, drei Encoder-Eingaenge,\\
    ein 4fach-DIP-Schalter, eine V.24-Schnittstelle, ein CAN-Interface und ein 2zeiliges LCD.\\
    Hard- und Software des AKSEN-Boards sind eine Entwicklung von Dipl.-Ing.(FH) Kai-Uwe Mrkor.\\
    "};/* mehr Prosa ist nicht ntig */

    /**********************************/
    /* ein eigenes strcpy             */
    /**********************************/
    char *strcpy (  char * d, char * s)
    {
        register char * d1 = d;

        while (*d1++ = *s++);

        return d;
    }

    /*******************************/
    /* Ausgabe des Pufferinhaltes */
    /*******************************/
    void ausgabe_lcd()
    {
        unsigned char i,j;

        for (i=0;i<2; i++)
        {
            lcd_setxy(i,0);
            for (j=0; j<16; j++) lcd_putchar( puffer[i][j]);
        }
    }

    /*******************/
    /* Initialisierung */
    /*******************/
    void init()
    {
        unsigned char i,j;

        laenge=sizeof(werbung);

        /* Den Puffer mit Leerzeichen fllen */
        for (i=0;i<2; i++)
            for (j=0; j<16; j++) puffer[i][j]=20; /* Leerzeichen */

        /* LCD "einschalten" */
        lcd_init();
    }

    /***********************/
    /* siehe Funktionsname */
    /***********************/
    void alles_an( void)
    {
        lcd_setup( DISPLAY_ON, CURSOR_OFF, CURSOR_NOBLINK );

        /* Die vier Motore einschalten */
        motor_pwm( 0, 10);
        motor_pwm( 1, 10);
        motor_pwm( 2, 10);
        motor_pwm( 3, 10);

        led(0, 1);
        led(1, 1);
        led(2, 1);
        led(3, 1);

        P1 &=0x7F;

    }

    /***********************/
    /* siehe Funktionsname */
    /***********************/
    void alles_aus( void)
    {
        //lcd_setup( DISPLAY_OFF, CURSOR_OFF, CURSOR_NOBLINK );

        /* Die vier Motore einschalten */
        motor_pwm( 0, 0);
        motor_pwm( 1, 0);
        motor_pwm( 2, 0);
        motor_pwm( 3, 0);

        led(0, 0);
        led(1, 0);
        led(2, 0);
        led(3, 0);

        P1 |=0x80;

    }

    void verschiebe( void)
    {
        unsigned char i;

        for (i=0; i<16; i++)
            puffer[0][i]=werbung[werbe_zeiger+i];

        werbe_zeiger++;

        if (werbung[werbe_zeiger+15]==0)
            werbe_zeiger=0;

    }

    /************************/
    /*                      */
    /************************/
    void action( void)
    {
        unsigned char i=0;

        //lcd++;

        //if (lcd==1)
        {
            strcpy( puffer[1],  " - AKSENBoard -  ");
        }

        //if (lcd==5)
        //{
        //	strcpy( puffer[1],  "  - Tutorial -   ");
        //	lcd=0;
        //}

        verschiebe();
        ausgabe_lcd();

        warte_zaehler++;

        //lcd_setxy(1,0);
        //lcd_long(warte_zaehler);

        if ( werbe_zeiger>=0 && werbe_zeiger < 20)
            //	if ( warte_zaehler<=80)
        {

            /*************/
            /* Laempchen */
            /*************/
            if (laempchen==0)
            {
                led(0, 0);
                led(1, 1);
                led(2, 0);
                led(3, 1);
                laempchen=1;
            }
            else
            {
                led(0, 1);
                led(1, 0);
                led(2, 1);
                led(3, 0);
                laempchen=0;
            }

            /*********/
            /* Motor */
            /*********/
            if (motor==0)
            {
                motor_richtung( 0, 0);
                motor_richtung( 1, 0);
                motor_richtung( 2, 0);
                motor_richtung( 3, 0);
                motor=1;
            }
            else
            {
                motor_richtung( 0, 1);
                motor_richtung( 1, 1);
                motor_richtung( 2, 1);
                motor_richtung( 3, 1);
                motor=0;
            }

            /************/
            /* Infrarot */
            /************/
            if (infrarot==0)
            {
                P1 &=0x7F;

                digital_out(8,0);
                digital_out(9,0);
                digital_out(10,0);
                digital_out(11,0);
                digital_out(12,0);
                digital_out(13,0);
                digital_out(14,0);
                digital_out(15,0);

                infrarot=1;
            }
            else
            {
                P1 |=0x80;

                digital_out(8,1);
                digital_out(9,1);
                digital_out(10,1);
                digital_out(11,1);
                digital_out(12,1);
                digital_out(13,1);
                digital_out(14,1);
                digital_out(15,1);

                infrarot=0;
            }

        }
        else
        {
            alles_aus();
            //if (warte_zaehler>=2*60*30) /* 2*60*30 -> 30 Minuten */
            //{
            //	warte_zaehler=0;
            //	alles_an();
            //}
        }

        /************************/
        /* halbe Sekunde warten */
        /************************/
        sleep(400);                               /* etwas warten */

    }

    /************************************************/
    /* MAIN-Routine									*/
    /************************************************/
    void AksenMain(void)
    {

        init();

        alles_an();

        do
        {
            action();
        }
        while(1);
    }
