/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : Don Mr 27 11:03:25 CET 2003
    copyright            : (C) 2003 by Kai-Uwe Mrkor
    email                : mrkor@fh-brandenburg.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/types.h>

#include <fcntl.h>

#include "serielle.h"






int main(int argc, char *argv[])
{
 IOStream   *serielle;

  printf("\nAkSen-Flasher V0.3, 10/06/2004, Kai-Uwe Mrkor\n");

  /* Aufrufkonvention ueberpruefen */
  if (argc  != 3)
   {
      printf("Aufruf:  aksen geraet hexdatei\n");
      printf("(Beispiel: aksen /dev/ttyS0 test.ihx)\n\n");

      return -1;
  }

  /* Oeffne Schnittstelle */
  serielle=oeffne_serielle( argv[1]); 
  if (serielle == FALSE) 
  {
    printf("\nFehler beim ffnen des Geraets %s.\n", argv[1]);
    return -1;
  }

  /* Initialisiere Schnittstelle */
  init_serielle(serielle); 
 
  /* Ueberpruefe Verbindung */
  if (anwesenheit(serielle)!=TRUE)
  {
    printf("\nAkSenBoard an %s nicht gefunden!!!\n", serielle->name);
    printf("- Richtige Schnittstelle ausgewaehlt?\n");
    printf("- Stromversorgung des AkSen-Boards in Ordnung?\n");
    printf("- AkSen-Board im Flash-Modus zurueckgesetzt?\n\n");

    close_serielle( serielle);
    return -1;
  }

  /*Beginn der bertragung */
  uebertragung(serielle, argv[2]);


  /* Schliesse ser. Schnittstelle */
  close_serielle( serielle);
 
  return EXIT_SUCCESS;
}
