/***************************************************************************
                          serielle.c  -  description
                             -------------------
    begin                : Don Mr 27 11:03:25 CET 2003
    copyright            : (C) 2003 by Kai-Uwe Mrkor
    email                : mrkor@fh-brandenburg.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/timeb.h>
#include <sys/ioctl.h>
#include <sys/select.h>
#include <sys/stat.h>

#include <fcntl.h>
#include <signal.h>

#include "serielle.h"



/*************************/
/* Serielle Schnittstelle ffnen */
/*************************/
IOStream *oeffne_serielle( char *name)
{
  IOStream *ret=malloc(sizeof(  IOStream));
  strncpy( ret->name, name, 100);
  ret->name[100-1]=0;
  ret->stream=open(ret->name, O_RDWR );

  return (ret->stream < 0 ? 0 : ret);
}

/*************************/
/* Serielle Schnittstelle init.     */
/*************************/
void init_serielle(  IOStream *s)
{
  char puffer[100+80];

  sprintf(puffer, "/bin/stty -F %s litout pass8 raw -echo 9600 > %s ",s->name, s->name);
  system(puffer);
}


/*************************/
/* Serielle Schnittstelle schlie. */
/*************************/
void  close_serielle( IOStream *s)
{
  close(s->stream);
}


/*************************/
/* Einzelnes Byte senden         */
/*************************/
void sende_byte( int c, IOStream *s)
{
  unsigned char buf=c;

  if (write(s->stream ? s->stream : 1, &buf, 1)!=1)
    printf("Fehler beim Senden");



}
    

/****************************/
/* Einzelnes Byte empfangen        */
/****************************/ 
int lese_byte( IOStream *s, int timeout)
{
  char c;
  int  nfound;
  fd_set read_set, write_set;
  struct timeval  timeval_timeout;

  timeval_timeout.tv_sec=(long)(timeout / 1000);
  timeval_timeout.tv_usec=1000L*(long)(timeout % 1000);

  /* Deskriptoren lschen */
 FD_ZERO(&read_set);
 FD_ZERO(&write_set);

  /* Lese-Deskripror */
  FD_SET(s->stream, &read_set);

  /* Time*/
  nfound=select(s->stream+1, &read_set, &write_set, NULL, &timeval_timeout);
  if (nfound <=0)
    return EOF;


  if(  read( s->stream, &c, 1) != 1)
    printf("Fehler beim Lesen");
                        
  return c;

}      




/*************************/
/* AkSen-Board suchen           */
/*************************/
int anwesenheit( IOStream *s)
{
  char zk[5];

  sende_byte(0x11, s);

  zk[0]=lese_byte(s,100);
  zk[1]=lese_byte(s,100);
  zk[2]=lese_byte(s,100);
  zk[3]=lese_byte(s,100);
  zk[4]=lese_byte(s,100);

  if (strncmp("HaLlO",zk,5)==0)
    return TRUE;
  else
    return FALSE;
   
}




int hole_int( char a, char b)
{
  int zahl_h, zahl_l;


  if (isdigit(a))
    zahl_h=a-0x30;
  else
    zahl_h=a-0x37;

  if (isdigit(b))
    zahl_l=b-0x30;
  else
    zahl_l=b-0x37;

   return 16*zahl_h+zahl_l;
}



int uebertragung( IOStream *s, char *dateiname)
{
  FILE *fdatei;
  int datei, i;
  struct stat datei_status;
  long datei_laenge;
  unsigned char zeichen, puffer[100], anzahl, adresse_l, adresse_h, type, dummy, verify;



  /* Dateigroesse ermitteln */
  if ((datei=open(dateiname, O_RDONLY)) == -1)
  {
    printf("\nHex-Datei %s nicht gefunden!\n", dateiname);
    return FALSE;
  }
  fstat(  datei,  &datei_status);
  close(datei);
  datei_laenge=(long)datei_status.st_size;


  if ((fdatei=fopen(dateiname, "rb")) == NULL)
  {
    printf("\nHex-Datei %s nicht gefunden!\n", dateiname);
    return FALSE;
  }

  sleep(1); /* 1 Sekunde verschnaufen*/

  do
  {
    do
    {
           fread( &zeichen,1,1,fdatei);
    }
    while (zeichen!=':');
    fread( &puffer,8,1,fdatei);
  
    anzahl=hole_int( puffer[0], puffer[1]);
    adresse_h=hole_int( puffer[2], puffer[3]);
    adresse_l=hole_int( puffer[4], puffer[5]);
    type=hole_int( puffer[6], puffer[7]);

    fread( puffer+8,(anzahl+1)*2,1,fdatei);
    printf("#");
    fflush(stdout);

    do
    {
        sende_byte(anzahl,s); //usleep(1);
        sende_byte(adresse_h,s); //usleep(1);
        sende_byte(adresse_l,s); //usleep(1);
        sende_byte(type,s); //usleep(1);

         for (i=0; i<anzahl; i++)
         {
            dummy=hole_int( puffer[i*2+8], puffer[i*2+8+1]);
            sende_byte(dummy,s); //usleep(1);
         }

        /* Pruefsumme senden */
        dummy=hole_int( puffer[anzahl*2+8], puffer[anzahl*2+8+1]);
        sende_byte(dummy,s);

        /* Type auswerten */
        if (type == 0x01)
        {
           /* Uebertragung abgeschlossen */
            fclose(fdatei);
            printf("\n");

            return TRUE;
        }

        usleep(2);
        verify=lese_byte(s, 200);
     }
    while(verify !=hole_int(puffer[anzahl*2+8], puffer[anzahl*2+8+1]));


  }
  while( (long)ftell(fdatei) < (long)datei_laenge );  /* Bis Dateiende erreicht*/

  return TRUE;
}


